/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "query_parser.y"

/*
 * query_parser.y - yacc/bison grammar for the PCP time series language
 *
 * Copyright (c) 2017-2022 Red Hat.
 * Copyright (c) 2020 Yushan ZHANG.
 * Copyright (c) 2022 Shiyao CHEN.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 */

#include <ctype.h>
#include "query.h"
#include "load.h"
#include "schema.h"
#include "util.h"
#include "libpcp.h"

typedef struct PARSER {
    char	*yy_input;
    char	*yy_lexicon;
    int		yy_lexpeek;
    int		yy_error;
    sds		yy_errstr;
    char	*yy_tokbuf;
    int 	yy_tokbuflen;
    meta_t	yy_meta;
    sds		yy_base;
    node_t	*yy_np;
    series_t	yy_series;
} PARSER;

typedef union {
    sds		s;
    node_t	*n;
    meta_t	m;
} YYSTYPE;

#define YYSTYPE_IS_DECLARED 1
static int yylex(YYSTYPE *, PARSER *);
static int yyerror(PARSER *, const char *);

static int series_lex(YYSTYPE *, PARSER *);
static int series_error(PARSER *, const char *);
static void gramerr(PARSER *, const char *, const char *, char *);

static node_t *newnode(int);
static node_t *newmetric(sds);
static node_t *newmetricquery(sds, node_t *);
static node_t *newtree(int, node_t *, node_t *);
static void newaligntime(PARSER *, sds);
static void newstarttime(PARSER *, sds);
static void newinterval(PARSER *, sds);
static void newendtime(PARSER *, sds);
static void newrange(PARSER *, sds);
static void newtimezone(PARSER *, sds);
static void newsamples(PARSER *, sds);
static void newoffset(PARSER *, sds);
static char *n_type_str(int);
static char *n_type_c(int);
static char *l_type_str(int);

#line 142 "query_parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "query_parser.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_L_UNDEF = 3,                    /* L_UNDEF  */
  YYSYMBOL_L_ERROR = 4,                    /* L_ERROR  */
  YYSYMBOL_L_EOS = 5,                      /* L_EOS  */
  YYSYMBOL_L_PLUS = 6,                     /* L_PLUS  */
  YYSYMBOL_L_MINUS = 7,                    /* L_MINUS  */
  YYSYMBOL_L_STAR = 8,                     /* L_STAR  */
  YYSYMBOL_L_SLASH = 9,                    /* L_SLASH  */
  YYSYMBOL_L_COLON = 10,                   /* L_COLON  */
  YYSYMBOL_L_LPAREN = 11,                  /* L_LPAREN  */
  YYSYMBOL_L_RPAREN = 12,                  /* L_RPAREN  */
  YYSYMBOL_L_LBRACE = 13,                  /* L_LBRACE  */
  YYSYMBOL_L_RBRACE = 14,                  /* L_RBRACE  */
  YYSYMBOL_L_LSQUARE = 15,                 /* L_LSQUARE  */
  YYSYMBOL_L_RSQUARE = 16,                 /* L_RSQUARE  */
  YYSYMBOL_L_ABS = 17,                     /* L_ABS  */
  YYSYMBOL_L_FLOOR = 18,                   /* L_FLOOR  */
  YYSYMBOL_L_LOG = 19,                     /* L_LOG  */
  YYSYMBOL_L_SQRT = 20,                    /* L_SQRT  */
  YYSYMBOL_L_ROUND = 21,                   /* L_ROUND  */
  YYSYMBOL_L_AVG = 22,                     /* L_AVG  */
  YYSYMBOL_L_AVG_INST = 23,                /* L_AVG_INST  */
  YYSYMBOL_L_AVG_SAMPLE = 24,              /* L_AVG_SAMPLE  */
  YYSYMBOL_L_COUNT = 25,                   /* L_COUNT  */
  YYSYMBOL_L_DELTA = 26,                   /* L_DELTA  */
  YYSYMBOL_L_MAX = 27,                     /* L_MAX  */
  YYSYMBOL_L_MAX_INST = 28,                /* L_MAX_INST  */
  YYSYMBOL_L_MAX_SAMPLE = 29,              /* L_MAX_SAMPLE  */
  YYSYMBOL_L_MIN = 30,                     /* L_MIN  */
  YYSYMBOL_L_MIN_INST = 31,                /* L_MIN_INST  */
  YYSYMBOL_L_MIN_SAMPLE = 32,              /* L_MIN_SAMPLE  */
  YYSYMBOL_L_SUM = 33,                     /* L_SUM  */
  YYSYMBOL_L_SUM_INST = 34,                /* L_SUM_INST  */
  YYSYMBOL_L_SUM_SAMPLE = 35,              /* L_SUM_SAMPLE  */
  YYSYMBOL_L_STDEV_INST = 36,              /* L_STDEV_INST  */
  YYSYMBOL_L_STDEV_SAMPLE = 37,            /* L_STDEV_SAMPLE  */
  YYSYMBOL_L_TOPK_INST = 38,               /* L_TOPK_INST  */
  YYSYMBOL_L_TOPK_SAMPLE = 39,             /* L_TOPK_SAMPLE  */
  YYSYMBOL_L_NTH_PERCENTILE_INST = 40,     /* L_NTH_PERCENTILE_INST  */
  YYSYMBOL_L_NTH_PERCENTILE_SAMPLE = 41,   /* L_NTH_PERCENTILE_SAMPLE  */
  YYSYMBOL_L_ANON = 42,                    /* L_ANON  */
  YYSYMBOL_L_RATE = 43,                    /* L_RATE  */
  YYSYMBOL_L_INSTANT = 44,                 /* L_INSTANT  */
  YYSYMBOL_L_LT = 45,                      /* L_LT  */
  YYSYMBOL_L_LEQ = 46,                     /* L_LEQ  */
  YYSYMBOL_L_EQ = 47,                      /* L_EQ  */
  YYSYMBOL_L_GLOB = 48,                    /* L_GLOB  */
  YYSYMBOL_L_GEQ = 49,                     /* L_GEQ  */
  YYSYMBOL_L_GT = 50,                      /* L_GT  */
  YYSYMBOL_L_NEQ = 51,                     /* L_NEQ  */
  YYSYMBOL_L_REQ = 52,                     /* L_REQ  */
  YYSYMBOL_L_RNE = 53,                     /* L_RNE  */
  YYSYMBOL_L_AND = 54,                     /* L_AND  */
  YYSYMBOL_L_OR = 55,                      /* L_OR  */
  YYSYMBOL_L_MKCONST = 56,                 /* L_MKCONST  */
  YYSYMBOL_L_RESCALE = 57,                 /* L_RESCALE  */
  YYSYMBOL_L_DEFINED = 58,                 /* L_DEFINED  */
  YYSYMBOL_L_TYPE = 59,                    /* L_TYPE  */
  YYSYMBOL_L_SEMANTICS = 60,               /* L_SEMANTICS  */
  YYSYMBOL_L_UNITS = 61,                   /* L_UNITS  */
  YYSYMBOL_L_ASSIGN = 62,                  /* L_ASSIGN  */
  YYSYMBOL_L_COMMA = 63,                   /* L_COMMA  */
  YYSYMBOL_L_INTERVAL = 64,                /* L_INTERVAL  */
  YYSYMBOL_L_TIMEZONE = 65,                /* L_TIMEZONE  */
  YYSYMBOL_L_ALIGN = 66,                   /* L_ALIGN  */
  YYSYMBOL_L_START = 67,                   /* L_START  */
  YYSYMBOL_L_FINISH = 68,                  /* L_FINISH  */
  YYSYMBOL_L_SAMPLES = 69,                 /* L_SAMPLES  */
  YYSYMBOL_L_OFFSET = 70,                  /* L_OFFSET  */
  YYSYMBOL_EVENT_UNIT = 71,                /* EVENT_UNIT  */
  YYSYMBOL_TIME_UNIT = 72,                 /* TIME_UNIT  */
  YYSYMBOL_SPACE_UNIT = 73,                /* SPACE_UNIT  */
  YYSYMBOL_L_INTEGER = 74,                 /* L_INTEGER  */
  YYSYMBOL_L_DOUBLE = 75,                  /* L_DOUBLE  */
  YYSYMBOL_L_NAME = 76,                    /* L_NAME  */
  YYSYMBOL_L_STRING = 77,                  /* L_STRING  */
  YYSYMBOL_L_RANGE = 78,                   /* L_RANGE  */
  YYSYMBOL_YYACCEPT = 79,                  /* $accept  */
  YYSYMBOL_query = 80,                     /* query  */
  YYSYMBOL_vector = 81,                    /* vector  */
  YYSYMBOL_exprlist = 82,                  /* exprlist  */
  YYSYMBOL_exprval = 83,                   /* exprval  */
  YYSYMBOL_string = 84,                    /* string  */
  YYSYMBOL_number = 85,                    /* number  */
  YYSYMBOL_integer = 86,                   /* integer  */
  YYSYMBOL_timelist = 87,                  /* timelist  */
  YYSYMBOL_timespec = 88,                  /* timespec  */
  YYSYMBOL_timeexpr = 89,                  /* timeexpr  */
  YYSYMBOL_expr = 90,                      /* expr  */
  YYSYMBOL_val_vec = 91,                   /* val_vec  */
  YYSYMBOL_sid_vec = 92,                   /* sid_vec  */
  YYSYMBOL_func_sid = 93,                  /* func_sid  */
  YYSYMBOL_arithmetic_expr_sid = 94,       /* arithmetic_expr_sid  */
  YYSYMBOL_func = 95,                      /* func  */
  YYSYMBOL_arithmetic_expression = 96      /* arithmetic_expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  81
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1198

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  79
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  18
/* YYNRULES -- Number of rules.  */
#define YYNRULES  188
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  572

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   333


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   197,   197,   198,   205,   210,   216,   218,   220,   226,
     229,   234,   239,   246,   252,   255,   256,   259,   264,   271,
     272,   279,   286,   287,   291,   292,   293,   297,   299,   301,
     303,   305,   307,   309,   311,   316,   318,   320,   322,   324,
     326,   330,   332,   334,   336,   340,   342,   347,   352,   360,
     364,   371,   376,   381,   386,   391,   396,   401,   406,   411,
     416,   421,   426,   431,   436,   441,   459,   477,   482,   487,
     492,   497,   502,   507,   512,   517,   522,   527,   533,   539,
     545,   551,   564,   577,   590,   603,   608,   613,   618,   623,
     628,   633,   638,   643,   648,   653,   659,   665,   670,   675,
     680,   685,   690,   695,   702,   708,   714,   720,   726,   732,
     738,   744,   750,   756,   762,   768,   774,   780,   786,   792,
     800,   805,   810,   815,   820,   825,   830,   835,   840,   845,
     850,   855,   860,   865,   870,   888,   906,   911,   916,   921,
     926,   932,   938,   943,   948,   953,   958,   963,   968,   973,
     978,   983,   988,   993,   998,  1003,  1008,  1013,  1018,  1024,
    1030,  1036,  1042,  1055,  1068,  1081,  1094,  1099,  1104,  1109,
    1114,  1119,  1124,  1131,  1137,  1143,  1149,  1155,  1161,  1167,
    1173,  1179,  1185,  1191,  1197,  1203,  1209,  1215,  1221
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "L_UNDEF", "L_ERROR",
  "L_EOS", "L_PLUS", "L_MINUS", "L_STAR", "L_SLASH", "L_COLON", "L_LPAREN",
  "L_RPAREN", "L_LBRACE", "L_RBRACE", "L_LSQUARE", "L_RSQUARE", "L_ABS",
  "L_FLOOR", "L_LOG", "L_SQRT", "L_ROUND", "L_AVG", "L_AVG_INST",
  "L_AVG_SAMPLE", "L_COUNT", "L_DELTA", "L_MAX", "L_MAX_INST",
  "L_MAX_SAMPLE", "L_MIN", "L_MIN_INST", "L_MIN_SAMPLE", "L_SUM",
  "L_SUM_INST", "L_SUM_SAMPLE", "L_STDEV_INST", "L_STDEV_SAMPLE",
  "L_TOPK_INST", "L_TOPK_SAMPLE", "L_NTH_PERCENTILE_INST",
  "L_NTH_PERCENTILE_SAMPLE", "L_ANON", "L_RATE", "L_INSTANT", "L_LT",
  "L_LEQ", "L_EQ", "L_GLOB", "L_GEQ", "L_GT", "L_NEQ", "L_REQ", "L_RNE",
  "L_AND", "L_OR", "L_MKCONST", "L_RESCALE", "L_DEFINED", "L_TYPE",
  "L_SEMANTICS", "L_UNITS", "L_ASSIGN", "L_COMMA", "L_INTERVAL",
  "L_TIMEZONE", "L_ALIGN", "L_START", "L_FINISH", "L_SAMPLES", "L_OFFSET",
  "EVENT_UNIT", "TIME_UNIT", "SPACE_UNIT", "L_INTEGER", "L_DOUBLE",
  "L_NAME", "L_STRING", "L_RANGE", "$accept", "query", "vector",
  "exprlist", "exprval", "string", "number", "integer", "timelist",
  "timespec", "timeexpr", "expr", "val_vec", "sid_vec", "func_sid",
  "arithmetic_expr_sid", "func", "arithmetic_expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333
};
#endif

#define YYPACT_NINF (-85)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     218,   -48,   481,   187,   193,   203,   210,   219,   232,   249,
     282,   306,   311,   323,   332,   363,   380,   382,   394,   413,
     415,   446,   452,   469,   470,   475,   533,   541,    46,   360,
     -85,   534,  1189,    84,   -85,   307,   -85,   -85,   -85,    25,
     649,    58,   477,   543,   544,   550,   551,   585,   586,   -85,
      32,   -85,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   -85,   -48,   481,
     268,   -85,   349,   349,   349,   349,   570,   570,   570,   570,
     -85,   570,   570,   570,   570,   -85,   349,   349,   349,   349,
      47,   -48,   581,   202,   202,   581,   581,   202,   202,   581,
     -48,   -48,   -48,   -48,   392,   563,   392,   392,   392,   552,
     571,   647,   481,   184,   220,   453,   467,   635,   642,   654,
     661,   674,    38,    48,   142,   204,   713,   720,   727,   734,
     741,   748,   755,   762,   769,   776,   783,   790,   797,   804,
     811,   818,   825,   832,   839,   846,   853,   860,   867,   874,
     881,   888,   895,   902,   909,   916,   923,   930,   937,   944,
     951,   958,   965,   972,   979,   986,   993,  1000,  1007,  1014,
    1021,  1028,  1035,  1042,  1049,  1056,  1063,  1070,  1077,  1084,
    1091,  1098,  1105,  1112,  1119,  1126,  1133,  1140,  1147,  1154,
     133,   181,   211,   216,   263,   356,   391,   395,   401,   405,
     409,   414,   476,   549,   608,   612,  1161,  1168,  1175,  1182,
     616,   622,   626,   630,    44,    33,   305,   -85,   653,   663,
     665,   666,   667,   673,   676,   677,   679,   680,   681,   712,
     719,   726,   733,   740,   747,   754,   761,   768,   775,   782,
     789,   796,   803,   308,   321,   387,   321,   387,   -85,   -85,
     -85,   -85,   810,   817,   824,   831,   838,   845,   852,   859,
     866,   873,   880,   887,   894,   901,   908,   915,   922,   929,
     936,   943,   950,   957,   964,   971,   978,   640,   447,   462,
     447,   462,   -85,   -85,   -85,   -85,   447,   462,   447,   462,
     -85,   -85,   -85,   -85,   321,   387,   321,   387,   -85,   -85,
     -85,   -85,   -85,   481,    58,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -48,   481,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   202,   -85,   202,   -85,   202,
     -85,   202,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   -85,   -85,   -85,   -85,   595,   668,   675,   682,
     258,   985,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   -48,   570,   570,
     570,   570,   570,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   -48,    93,    80,    94,   984,   991,   992,
     998,   999,  1005,  1006,  1012,  1013,  1019,  1020,  1026,  1027,
    1033,  1034,  1040,  1041,  1047,  1048,  1054,  1055,  1061,  1062,
    1068,   -85,   481,   -85,    92,   138,  1076,   709,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   137,   709,   -85,   -85,   481,  1082,   199,
     -85,   -85
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
       2,     0,     0,     0,   103,     0,   172,    18,    17,     0,
       0,    14,     0,     0,     0,     0,     0,     0,     0,    34,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    10,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,     0,
      12,     0,     0,     0,     0,    11,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,     3,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   173,   174,   177,   178,   181,   182,
     185,   186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,   104,   105,
     108,   109,   112,   113,   116,   117,   106,   107,   110,   111,
     114,   115,   118,   119,   175,   176,   179,   180,   183,   184,
     187,   188,     7,     0,    13,    21,    20,    43,    15,    16,
      19,    35,    36,    37,    44,    38,    39,    40,    41,    42,
      45,    46,    25,    26,    24,    27,    28,    31,    32,    33,
      29,    30,     9,    22,     0,     0,   136,    91,    92,   137,
     138,    93,    94,   139,   142,     0,    97,     0,    98,     0,
     143,     0,   144,    99,   100,   145,   146,   101,   102,   147,
     166,    85,    86,   167,   168,    87,    88,   169,   170,    89,
      90,   171,   122,    53,    54,   123,   124,    55,    56,   125,
     126,    57,    58,   127,   128,    59,    60,   129,   130,    61,
      62,   131,   132,    63,    64,   133,   148,    67,    68,   149,
     150,    69,    70,   151,   152,    71,    72,   153,   154,    73,
      74,   155,   156,    75,    76,   157,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   120,    51,    52,   121,     0,     0,     0,     0,
      49,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     0,     8,     0,     0,     0,    49,    48,   140,
      95,    96,   141,   158,    77,    78,   159,   160,    79,    80,
     161,   162,    81,    82,   163,   164,    83,    84,   165,   134,
      65,    66,   135,     0,     0,    49,     6,     0,    47,     0,
       5,    47
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -85,   -85,   651,   -25,   159,   222,   -77,   277,   -79,   -84,
     644,    90,    62,   -51,    11,   -85,   110,   -85
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    29,    30,    39,   317,    40,   319,   320,    50,   335,
      51,    41,    31,    32,    33,    34,    35,    36
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     225,   125,   129,   133,   137,   141,   145,   149,   153,   157,
     161,   165,   169,   173,   177,   181,   185,   189,   193,   197,
     201,   205,   209,   213,   217,   221,   321,   322,    37,    38,
     325,   326,   337,   338,   339,   288,   290,   292,   294,   100,
     296,   298,   300,   302,    82,    83,    84,    85,   121,   451,
     354,    77,   312,   224,    86,    87,    88,    89,   450,    78,
     356,    79,   313,   126,   130,   134,   138,   142,   146,   150,
     154,   158,   162,   166,   170,   174,   178,   182,   186,   190,
     194,   198,   202,   206,   210,   214,   218,   222,   101,    90,
      91,    92,    93,    94,   537,   122,   122,   289,   291,   293,
     295,   355,   297,   299,   301,   303,   564,   101,    80,   536,
     538,   357,   112,   113,   124,   128,   132,   136,   140,   144,
     148,   152,   156,   160,   164,   168,   172,   176,   180,   184,
     188,   192,   196,   200,   204,   208,   212,   216,   220,    82,
      83,    84,    85,   101,   254,   256,   258,   260,    91,    92,
      93,    94,   565,   568,   358,   101,   122,   122,   304,   306,
     308,   310,   127,   131,   135,   139,   143,   147,   151,   155,
     159,   163,   167,   171,   175,   179,   183,   187,   191,   195,
     199,   203,   207,   211,   215,   219,   223,    86,    87,    88,
      89,   314,   255,   257,   259,   261,   426,   344,    52,   345,
     122,   101,   330,   331,    53,   359,   305,   307,   309,   311,
      96,    97,    98,    99,    54,   571,   360,    91,    92,    93,
      94,    55,    96,    97,    98,    99,    82,    83,    84,    85,
      56,     1,   346,     2,   504,     3,     4,     5,     6,     7,
       8,     9,    10,    57,   427,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      58,    26,   122,   531,   323,   324,   506,   361,   327,    82,
      83,    84,    85,   532,   428,    27,   315,   316,   507,   429,
     508,     1,   509,     2,   510,     3,     4,     5,     6,     7,
       8,     9,    10,    59,    28,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      77,    26,    95,    96,    97,    98,    99,    60,    78,   505,
      79,   477,    61,   345,   318,    27,   430,   318,   318,    84,
      85,   318,   328,   329,    62,     3,     4,     5,     6,     7,
       8,     9,    10,    63,   226,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      81,    26,    86,    87,    88,    89,   228,   229,   230,   231,
     232,   233,   234,   235,    64,    27,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    65,   251,    66,   123,    98,    99,    91,    92,    93,
      94,    96,    97,    98,    99,    67,   252,    82,    83,    84,
      85,    86,    87,    88,    89,    91,    92,    93,    94,   431,
      96,    97,    98,    99,    68,   253,    69,   125,   129,   133,
     137,   141,   145,   149,   153,   157,   161,   165,   169,   173,
     177,   181,   185,   189,   193,   197,   201,   205,   209,   213,
     217,   221,   534,   563,   432,    88,    89,    70,   433,    86,
      87,    88,    89,    71,   434,   347,   332,   333,   435,   334,
      93,    94,   436,    91,    92,    93,    94,   437,   535,   348,
      72,    73,    82,    83,    84,    85,    74,   114,   569,   126,
     130,   134,   138,   142,   146,   150,   154,   158,   162,   166,
     170,   174,   178,   182,   186,   190,   194,   198,   202,   206,
     210,   214,   218,   222,   124,   128,   132,   136,   140,   144,
     148,   152,   156,   160,   164,   168,   172,   176,   180,   184,
     188,   192,   196,   200,   204,   208,   212,   216,   220,   438,
      82,    83,    84,    85,    75,    42,    43,    44,    45,    46,
      47,    48,    76,   115,   116,    86,    87,    88,    89,    49,
     117,   118,   127,   131,   135,   139,   143,   147,   151,   155,
     159,   163,   167,   171,   175,   179,   183,   187,   191,   195,
     199,   203,   207,   211,   215,   219,   223,   262,   263,   264,
     265,   266,   267,   268,   269,   119,   120,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   439,   285,    91,    92,    93,    94,    96,    97,
      98,    99,    82,    83,    84,    85,   340,   286,    86,    87,
      88,    89,    91,    92,    93,    94,    96,    97,    98,    99,
     336,    96,    97,    98,    99,   341,   287,   349,    82,    83,
      84,    85,   342,   503,   350,   315,   316,    37,    38,   102,
      86,    87,    88,    89,   452,   315,   351,    91,    92,    93,
      94,   440,   527,   352,   453,   441,   454,   455,   456,   446,
      96,    97,    98,    99,   457,   447,   353,   458,   459,   448,
     460,   461,   462,   449,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,    82,
      83,    84,    85,   463,   567,   362,    86,    87,    88,    89,
     464,   227,   363,    91,    92,    93,    94,   465,     0,   364,
      96,    97,    98,    99,   466,   528,   365,    82,    83,    84,
      85,   467,   529,   366,    86,    87,    88,    89,   468,   530,
     367,    91,    92,    93,    94,   469,   343,   368,    96,    97,
      98,    99,   470,     0,   369,    82,    83,    84,    85,   471,
       0,   370,    86,    87,    88,    89,   472,     0,   371,    91,
      92,    93,    94,   473,     0,   372,    96,    97,    98,    99,
     474,     0,   373,    82,    83,    84,    85,   475,     0,   374,
      86,    87,    88,    89,   476,     0,   375,    91,    92,    93,
      94,   478,     0,   376,    96,    97,    98,    99,   479,     0,
     377,    82,    83,    84,    85,   480,     0,   378,    86,    87,
      88,    89,   481,     0,   379,    91,    92,    93,    94,   482,
       0,   380,    96,    97,    98,    99,   483,     0,   381,    82,
      83,    84,    85,   484,     0,   382,    86,    87,    88,    89,
     485,     0,   383,    91,    92,    93,    94,   486,     0,   384,
      96,    97,    98,    99,   487,     0,   385,    82,    83,    84,
      85,   488,     0,   386,    86,    87,    88,    89,   489,     0,
     387,    91,    92,    93,    94,   490,     0,   388,    96,    97,
      98,    99,   491,     0,   389,    82,    83,    84,    85,   492,
       0,   390,    86,    87,    88,    89,   493,     0,   391,    91,
      92,    93,    94,   494,     0,   392,    96,    97,    98,    99,
     495,     0,   393,    82,    83,    84,    85,   496,     0,   394,
      86,    87,    88,    89,   497,     0,   395,    91,    92,    93,
      94,   498,     0,   396,    96,    97,    98,    99,   499,     0,
     397,    82,    83,    84,    85,   500,     0,   398,    86,    87,
      88,    89,   501,     0,   399,    91,    92,    93,    94,   502,
     533,   400,    96,    97,    98,    99,   539,     0,   401,    82,
      83,    84,    85,   540,   541,   402,    86,    87,    88,    89,
     542,   543,   403,    91,    92,    93,    94,   544,   545,   404,
      96,    97,    98,    99,   546,   547,   405,    82,    83,    84,
      85,   548,   549,   406,    86,    87,    88,    89,   550,   551,
     407,    91,    92,    93,    94,   552,   553,   408,    96,    97,
      98,    99,   554,   555,   409,    82,    83,    84,    85,   556,
     557,   410,    86,    87,    88,    89,   558,   559,   411,    91,
      92,    93,    94,   560,   561,   412,    96,    97,    98,    99,
     562,   566,   413,    82,    83,    84,    85,   570,     0,   414,
      86,    87,    88,    89,     0,     0,   415,    91,    92,    93,
      94,     0,     0,   416,    96,    97,    98,    99,     0,     0,
     417,    82,    83,    84,    85,     0,     0,   418,    86,    87,
      88,    89,     0,     0,   419,    91,    92,    93,    94,     0,
       0,   420,    96,    97,    98,    99,     0,     0,   421,    82,
      83,    84,    85,     0,     0,   422,    86,    87,    88,    89,
       0,     0,   423,    91,    92,    93,    94,     0,     0,   424,
      96,    97,    98,    99,     0,     0,   425,    82,    83,    84,
      85,     0,     0,   442,    86,    87,    88,    89,     0,     0,
     443,    91,    92,    93,    94,     0,     0,   444,    96,    97,
      98,    99,     0,     0,   445,    86,    87,    88,    89
};

static const yytype_int16 yycheck[] =
{
      79,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,   103,   104,    76,    77,
     107,   108,   116,   117,   118,    86,    87,    88,    89,    14,
      91,    92,    93,    94,     6,     7,     8,     9,    16,    16,
      12,     5,     5,    78,     6,     7,     8,     9,    14,    13,
      12,    15,    15,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    63,     5,
       6,     7,     8,     9,    14,    63,    63,    86,    87,    88,
      89,    63,    91,    92,    93,    94,    14,    63,    62,    16,
      16,    63,    54,    55,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,     6,
       7,     8,     9,    63,    82,    83,    84,    85,     6,     7,
       8,     9,    14,    16,    12,    63,    63,    63,    96,    97,
      98,    99,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,     6,     7,     8,
       9,   101,    82,    83,    84,    85,    63,    13,    11,    15,
      63,    63,   112,   113,    11,    63,    96,    97,    98,    99,
       6,     7,     8,     9,    11,    16,    12,     6,     7,     8,
       9,    11,     6,     7,     8,     9,     6,     7,     8,     9,
      11,    13,    12,    15,   313,    17,    18,    19,    20,    21,
      22,    23,    24,    11,    63,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      11,    43,    63,     5,   105,   106,   345,    63,   109,     6,
       7,     8,     9,    15,    63,    57,    74,    75,   355,    63,
     357,    13,   359,    15,   361,    17,    18,    19,    20,    21,
      22,    23,    24,    11,    76,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
       5,    43,     5,     6,     7,     8,     9,    11,    13,   344,
      15,    13,    11,    15,   102,    57,    63,   105,   106,     8,
       9,   109,   110,   111,    11,    17,    18,    19,    20,    21,
      22,    23,    24,    11,    76,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
       0,    43,     6,     7,     8,     9,    17,    18,    19,    20,
      21,    22,    23,    24,    11,    57,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    11,    43,    11,    76,     8,     9,     6,     7,     8,
       9,     6,     7,     8,     9,    11,    57,     6,     7,     8,
       9,     6,     7,     8,     9,     6,     7,     8,     9,    63,
       6,     7,     8,     9,    11,    76,    11,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   477,   532,    63,     8,     9,    11,    63,     6,
       7,     8,     9,    11,    63,    12,    74,    75,    63,    77,
       8,     9,    63,     6,     7,     8,     9,    63,   503,    12,
      11,    11,     6,     7,     8,     9,    11,    10,   567,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,    63,
       6,     7,     8,     9,    11,    64,    65,    66,    67,    68,
      69,    70,    11,    10,    10,     6,     7,     8,     9,    78,
      10,    10,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,    17,    18,    19,
      20,    21,    22,    23,    24,    10,    10,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    63,    43,     6,     7,     8,     9,     6,     7,
       8,     9,     6,     7,     8,     9,    74,    57,     6,     7,
       8,     9,     6,     7,     8,     9,     6,     7,     8,     9,
      77,     6,     7,     8,     9,    74,    76,    12,     6,     7,
       8,     9,     5,    13,    12,    74,    75,    76,    77,    10,
       6,     7,     8,     9,    11,    74,    12,     6,     7,     8,
       9,    63,    77,    12,    11,    63,    11,    11,    11,    63,
       6,     7,     8,     9,    11,    63,    12,    11,    11,    63,
      11,    11,    11,    63,    45,    46,    47,    48,    49,    50,
      51,    52,    53,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,     6,
       7,     8,     9,    11,    15,    12,     6,     7,     8,     9,
      11,    80,    12,     6,     7,     8,     9,    11,    -1,    12,
       6,     7,     8,     9,    11,    77,    12,     6,     7,     8,
       9,    11,    77,    12,     6,     7,     8,     9,    11,    77,
      12,     6,     7,     8,     9,    11,   122,    12,     6,     7,
       8,     9,    11,    -1,    12,     6,     7,     8,     9,    11,
      -1,    12,     6,     7,     8,     9,    11,    -1,    12,     6,
       7,     8,     9,    11,    -1,    12,     6,     7,     8,     9,
      11,    -1,    12,     6,     7,     8,     9,    11,    -1,    12,
       6,     7,     8,     9,    11,    -1,    12,     6,     7,     8,
       9,    11,    -1,    12,     6,     7,     8,     9,    11,    -1,
      12,     6,     7,     8,     9,    11,    -1,    12,     6,     7,
       8,     9,    11,    -1,    12,     6,     7,     8,     9,    11,
      -1,    12,     6,     7,     8,     9,    11,    -1,    12,     6,
       7,     8,     9,    11,    -1,    12,     6,     7,     8,     9,
      11,    -1,    12,     6,     7,     8,     9,    11,    -1,    12,
       6,     7,     8,     9,    11,    -1,    12,     6,     7,     8,
       9,    11,    -1,    12,     6,     7,     8,     9,    11,    -1,
      12,     6,     7,     8,     9,    11,    -1,    12,     6,     7,
       8,     9,    11,    -1,    12,     6,     7,     8,     9,    11,
      -1,    12,     6,     7,     8,     9,    11,    -1,    12,     6,
       7,     8,     9,    11,    -1,    12,     6,     7,     8,     9,
      11,    -1,    12,     6,     7,     8,     9,    11,    -1,    12,
       6,     7,     8,     9,    11,    -1,    12,     6,     7,     8,
       9,    11,    -1,    12,     6,     7,     8,     9,    11,    -1,
      12,     6,     7,     8,     9,    11,    -1,    12,     6,     7,
       8,     9,    11,    -1,    12,     6,     7,     8,     9,    11,
       5,    12,     6,     7,     8,     9,    12,    -1,    12,     6,
       7,     8,     9,    12,    12,    12,     6,     7,     8,     9,
      12,    12,    12,     6,     7,     8,     9,    12,    12,    12,
       6,     7,     8,     9,    12,    12,    12,     6,     7,     8,
       9,    12,    12,    12,     6,     7,     8,     9,    12,    12,
      12,     6,     7,     8,     9,    12,    12,    12,     6,     7,
       8,     9,    12,    12,    12,     6,     7,     8,     9,    12,
      12,    12,     6,     7,     8,     9,    12,    12,    12,     6,
       7,     8,     9,    12,    12,    12,     6,     7,     8,     9,
      12,     5,    12,     6,     7,     8,     9,     5,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    13,    15,    17,    18,    19,    20,    21,    22,    23,
      24,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    43,    57,    76,    80,
      81,    91,    92,    93,    94,    95,    96,    76,    77,    82,
      84,    90,    64,    65,    66,    67,    68,    69,    70,    78,
      87,    89,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,     5,    13,    15,
      62,     0,     6,     7,     8,     9,     6,     7,     8,     9,
       5,     6,     7,     8,     9,     5,     6,     7,     8,     9,
      14,    63,    10,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    10,    10,    10,    10,    10,    10,
      10,    16,    63,    76,    91,    92,    93,    95,    91,    92,
      93,    95,    91,    92,    93,    95,    91,    92,    93,    95,
      91,    92,    93,    95,    91,    92,    93,    95,    91,    92,
      93,    95,    91,    92,    93,    95,    91,    92,    93,    95,
      91,    92,    93,    95,    91,    92,    93,    95,    91,    92,
      93,    95,    91,    92,    93,    95,    91,    92,    93,    95,
      91,    92,    93,    95,    91,    92,    93,    95,    91,    92,
      93,    95,    91,    92,    93,    95,    91,    92,    93,    95,
      91,    92,    93,    95,    91,    92,    93,    95,    91,    92,
      93,    95,    91,    92,    93,    95,    91,    92,    93,    95,
      91,    92,    93,    95,    82,    87,    76,    81,    17,    18,
      19,    20,    21,    22,    23,    24,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    43,    57,    76,    91,    95,    91,    95,    91,    95,
      91,    95,    17,    18,    19,    20,    21,    22,    23,    24,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    43,    57,    76,    92,    93,
      92,    93,    92,    93,    92,    93,    92,    93,    92,    93,
      92,    93,    92,    93,    91,    95,    91,    95,    91,    95,
      91,    95,     5,    15,    90,    74,    75,    83,    84,    85,
      86,    85,    85,    83,    83,    85,    85,    83,    84,    84,
      90,    90,    74,    75,    77,    88,    77,    88,    88,    88,
      74,    74,     5,    89,    13,    15,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    63,    12,    63,    12,    63,
      12,    63,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    12,    12,    12,    12,    63,    63,    63,    63,
      14,    16,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    13,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    13,    87,    82,    87,    85,    85,    85,
      85,    86,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    86,    86,    86,    86,    86,    86,    77,    77,    77,
      77,     5,    15,     5,    82,    82,    16,    14,    16,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    87,    14,    14,     5,    15,    16,    87,
       5,    16
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    79,    80,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    82,    82,    83,    83,    84,    84,    85,
      85,    86,    87,    87,    88,    88,    88,    89,    89,    89,
      89,    89,    89,    89,    89,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    91,    91,    92,
      92,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     5,     8,     7,     4,     5,     4,
       2,     2,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     7,     4,     4,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     6,     6,     6,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     4,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     6,     6,     4,     4,     4,     4,
       6,     6,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     6,     6,
       6,     6,     6,     6,     6,     6,     4,     4,     4,     4,
       4,     4,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (lp, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, lp); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, PARSER *lp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (lp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, PARSER *lp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, lp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, PARSER *lp)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], lp);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, lp); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, PARSER *lp)
{
  YYUSE (yyvaluep);
  YYUSE (lp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (PARSER *lp)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, lp);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* query: L_NAME L_ASSIGN vector  */
#line 199 "query_parser.y"
                { lp->yy_series.name = (yyvsp[-2].s);
		  (yyval.n) = lp->yy_series.expr;
		  YYACCEPT;
		}
#line 1713 "query_parser.tab.c"
    break;

  case 4: /* vector: L_NAME L_LBRACE exprlist L_RBRACE L_EOS  */
#line 206 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-4].s), (yyvsp[-2].n));
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1722 "query_parser.tab.c"
    break;

  case 5: /* vector: L_NAME L_LBRACE exprlist L_RBRACE L_LSQUARE timelist L_RSQUARE L_EOS  */
#line 211 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-7].s), (yyvsp[-5].n));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1732 "query_parser.tab.c"
    break;

  case 6: /* vector: L_LBRACE exprlist L_RBRACE L_LSQUARE timelist L_RSQUARE L_EOS  */
#line 217 "query_parser.y"
                { lp->yy_np = lp->yy_series.expr = (yyvsp[-5].n); YYACCEPT; }
#line 1738 "query_parser.tab.c"
    break;

  case 7: /* vector: L_LBRACE exprlist L_RBRACE L_EOS  */
#line 219 "query_parser.y"
                { lp->yy_np = lp->yy_series.expr = (yyvsp[-2].n); YYACCEPT; }
#line 1744 "query_parser.tab.c"
    break;

  case 8: /* vector: L_NAME L_LSQUARE timelist L_RSQUARE L_EOS  */
#line 221 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[-4].s));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1754 "query_parser.tab.c"
    break;

  case 9: /* vector: L_LSQUARE timelist L_RSQUARE L_EOS  */
#line 227 "query_parser.y"
                { YYACCEPT;
		}
#line 1761 "query_parser.tab.c"
    break;

  case 10: /* vector: L_NAME L_EOS  */
#line 230 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[-1].s));
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1770 "query_parser.tab.c"
    break;

  case 11: /* vector: func L_EOS  */
#line 235 "query_parser.y"
                { lp->yy_np = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1779 "query_parser.tab.c"
    break;

  case 12: /* vector: func_sid L_EOS  */
#line 240 "query_parser.y"
                { lp->yy_np = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1788 "query_parser.tab.c"
    break;

  case 13: /* exprlist: exprlist L_COMMA expr  */
#line 247 "query_parser.y"
                { lp->yy_np = newnode(N_AND);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_np;
		}
#line 1798 "query_parser.tab.c"
    break;

  case 17: /* string: L_STRING  */
#line 260 "query_parser.y"
                { lp->yy_np = newnode(N_STRING);
		  lp->yy_np->value = (yyvsp[0].s);
		  (yyval.n) = lp->yy_np;
		}
#line 1807 "query_parser.tab.c"
    break;

  case 18: /* string: L_NAME  */
#line 265 "query_parser.y"
                { lp->yy_np = newnode(N_NAME);
		  lp->yy_np->value = (yyvsp[0].s);
		  (yyval.n) = lp->yy_np;
		}
#line 1816 "query_parser.tab.c"
    break;

  case 20: /* number: L_DOUBLE  */
#line 273 "query_parser.y"
                { lp->yy_np = newnode(N_DOUBLE);
		  lp->yy_np->value = (yyvsp[0].s);
		  (yyval.n) = lp->yy_np;
		}
#line 1825 "query_parser.tab.c"
    break;

  case 21: /* integer: L_INTEGER  */
#line 280 "query_parser.y"
                { lp->yy_np = newnode(N_INTEGER);
		  lp->yy_np->value = (yyvsp[0].s);
		  (yyval.n) = lp->yy_np;
		}
#line 1834 "query_parser.tab.c"
    break;

  case 27: /* timeexpr: L_INTERVAL L_COLON timespec  */
#line 298 "query_parser.y"
                { newinterval(lp, (yyvsp[0].s)); }
#line 1840 "query_parser.tab.c"
    break;

  case 28: /* timeexpr: L_TIMEZONE L_COLON L_STRING  */
#line 300 "query_parser.y"
                { newtimezone(lp, (yyvsp[0].s)); }
#line 1846 "query_parser.tab.c"
    break;

  case 29: /* timeexpr: L_SAMPLES L_COLON L_INTEGER  */
#line 302 "query_parser.y"
                { newsamples(lp, (yyvsp[0].s)); }
#line 1852 "query_parser.tab.c"
    break;

  case 30: /* timeexpr: L_OFFSET L_COLON L_INTEGER  */
#line 304 "query_parser.y"
                { newoffset(lp, (yyvsp[0].s)); }
#line 1858 "query_parser.tab.c"
    break;

  case 31: /* timeexpr: L_ALIGN L_COLON timespec  */
#line 306 "query_parser.y"
                { newaligntime(lp, (yyvsp[0].s)); }
#line 1864 "query_parser.tab.c"
    break;

  case 32: /* timeexpr: L_START L_COLON timespec  */
#line 308 "query_parser.y"
                { newstarttime(lp, (yyvsp[0].s)); }
#line 1870 "query_parser.tab.c"
    break;

  case 33: /* timeexpr: L_FINISH L_COLON timespec  */
#line 310 "query_parser.y"
                { newendtime(lp, (yyvsp[0].s)); }
#line 1876 "query_parser.tab.c"
    break;

  case 34: /* timeexpr: L_RANGE  */
#line 312 "query_parser.y"
                { newrange(lp, (yyvsp[0].s)); }
#line 1882 "query_parser.tab.c"
    break;

  case 35: /* expr: string L_LT number  */
#line 317 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_LT, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1888 "query_parser.tab.c"
    break;

  case 36: /* expr: string L_LEQ number  */
#line 319 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_LEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1894 "query_parser.tab.c"
    break;

  case 37: /* expr: string L_EQ exprval  */
#line 321 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_EQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1900 "query_parser.tab.c"
    break;

  case 38: /* expr: string L_GEQ number  */
#line 323 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1906 "query_parser.tab.c"
    break;

  case 39: /* expr: string L_GT number  */
#line 325 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GT, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1912 "query_parser.tab.c"
    break;

  case 40: /* expr: string L_NEQ exprval  */
#line 327 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_NEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1918 "query_parser.tab.c"
    break;

  case 41: /* expr: string L_REQ string  */
#line 331 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_REQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1924 "query_parser.tab.c"
    break;

  case 42: /* expr: string L_RNE string  */
#line 333 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_RNE, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1930 "query_parser.tab.c"
    break;

  case 43: /* expr: string L_COLON exprval  */
#line 335 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1936 "query_parser.tab.c"
    break;

  case 44: /* expr: string L_GLOB exprval  */
#line 337 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1942 "query_parser.tab.c"
    break;

  case 45: /* expr: expr L_AND expr  */
#line 341 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_AND, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1948 "query_parser.tab.c"
    break;

  case 46: /* expr: expr L_OR expr  */
#line 343 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_OR, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1954 "query_parser.tab.c"
    break;

  case 47: /* val_vec: L_NAME L_LBRACE exprlist L_RBRACE L_LSQUARE timelist L_RSQUARE  */
#line 348 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-6].s), (yyvsp[-4].n));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1963 "query_parser.tab.c"
    break;

  case 48: /* val_vec: L_NAME L_LSQUARE timelist L_RSQUARE  */
#line 353 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[-3].s));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1972 "query_parser.tab.c"
    break;

  case 49: /* sid_vec: L_NAME L_LBRACE exprlist L_RBRACE  */
#line 361 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-3].s), (yyvsp[-1].n));
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                }
#line 1980 "query_parser.tab.c"
    break;

  case 50: /* sid_vec: L_NAME  */
#line 365 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[0].s));
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                }
#line 1988 "query_parser.tab.c"
    break;

  case 51: /* func_sid: L_RATE L_LPAREN sid_vec L_RPAREN  */
#line 372 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1997 "query_parser.tab.c"
    break;

  case 52: /* func_sid: L_RATE L_LPAREN func_sid L_RPAREN  */
#line 377 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2006 "query_parser.tab.c"
    break;

  case 53: /* func_sid: L_MAX L_LPAREN sid_vec L_RPAREN  */
#line 382 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2015 "query_parser.tab.c"
    break;

  case 54: /* func_sid: L_MAX L_LPAREN func_sid L_RPAREN  */
#line 387 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2024 "query_parser.tab.c"
    break;

  case 55: /* func_sid: L_MAX_INST L_LPAREN sid_vec L_RPAREN  */
#line 392 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2033 "query_parser.tab.c"
    break;

  case 56: /* func_sid: L_MAX_INST L_LPAREN func_sid L_RPAREN  */
#line 397 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2042 "query_parser.tab.c"
    break;

  case 57: /* func_sid: L_MAX_SAMPLE L_LPAREN sid_vec L_RPAREN  */
#line 402 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2051 "query_parser.tab.c"
    break;

  case 58: /* func_sid: L_MAX_SAMPLE L_LPAREN func_sid L_RPAREN  */
#line 407 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2060 "query_parser.tab.c"
    break;

  case 59: /* func_sid: L_MIN L_LPAREN sid_vec L_RPAREN  */
#line 412 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2069 "query_parser.tab.c"
    break;

  case 60: /* func_sid: L_MIN L_LPAREN func_sid L_RPAREN  */
#line 417 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2078 "query_parser.tab.c"
    break;

  case 61: /* func_sid: L_MIN_INST L_LPAREN sid_vec L_RPAREN  */
#line 422 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2087 "query_parser.tab.c"
    break;

  case 62: /* func_sid: L_MIN_INST L_LPAREN func_sid L_RPAREN  */
#line 427 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2096 "query_parser.tab.c"
    break;

  case 63: /* func_sid: L_MIN_SAMPLE L_LPAREN sid_vec L_RPAREN  */
#line 432 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2105 "query_parser.tab.c"
    break;

  case 64: /* func_sid: L_MIN_SAMPLE L_LPAREN func_sid L_RPAREN  */
#line 437 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2114 "query_parser.tab.c"
    break;

  case 65: /* func_sid: L_RESCALE L_LPAREN sid_vec L_COMMA L_STRING L_RPAREN  */
#line 442 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2136 "query_parser.tab.c"
    break;

  case 66: /* func_sid: L_RESCALE L_LPAREN func_sid L_COMMA L_STRING L_RPAREN  */
#line 460 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2158 "query_parser.tab.c"
    break;

  case 67: /* func_sid: L_SUM L_LPAREN sid_vec L_RPAREN  */
#line 478 "query_parser.y"
                { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2167 "query_parser.tab.c"
    break;

  case 68: /* func_sid: L_SUM L_LPAREN func_sid L_RPAREN  */
#line 483 "query_parser.y"
                { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2176 "query_parser.tab.c"
    break;

  case 69: /* func_sid: L_SUM_INST L_LPAREN sid_vec L_RPAREN  */
#line 488 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2185 "query_parser.tab.c"
    break;

  case 70: /* func_sid: L_SUM_INST L_LPAREN func_sid L_RPAREN  */
#line 493 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2194 "query_parser.tab.c"
    break;

  case 71: /* func_sid: L_SUM_SAMPLE L_LPAREN sid_vec L_RPAREN  */
#line 498 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2203 "query_parser.tab.c"
    break;

  case 72: /* func_sid: L_SUM_SAMPLE L_LPAREN func_sid L_RPAREN  */
#line 503 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2212 "query_parser.tab.c"
    break;

  case 73: /* func_sid: L_STDEV_INST L_LPAREN sid_vec L_RPAREN  */
#line 508 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2221 "query_parser.tab.c"
    break;

  case 74: /* func_sid: L_STDEV_INST L_LPAREN func_sid L_RPAREN  */
#line 513 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2230 "query_parser.tab.c"
    break;

  case 75: /* func_sid: L_STDEV_SAMPLE L_LPAREN sid_vec L_RPAREN  */
#line 518 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2239 "query_parser.tab.c"
    break;

  case 76: /* func_sid: L_STDEV_SAMPLE L_LPAREN func_sid L_RPAREN  */
#line 523 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2248 "query_parser.tab.c"
    break;

  case 77: /* func_sid: L_TOPK_INST L_LPAREN sid_vec L_COMMA integer L_RPAREN  */
#line 528 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2258 "query_parser.tab.c"
    break;

  case 78: /* func_sid: L_TOPK_INST L_LPAREN func_sid L_COMMA integer L_RPAREN  */
#line 534 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2268 "query_parser.tab.c"
    break;

  case 79: /* func_sid: L_TOPK_SAMPLE L_LPAREN sid_vec L_COMMA integer L_RPAREN  */
#line 540 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2278 "query_parser.tab.c"
    break;

  case 80: /* func_sid: L_TOPK_SAMPLE L_LPAREN func_sid L_COMMA integer L_RPAREN  */
#line 546 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2288 "query_parser.tab.c"
    break;

  case 81: /* func_sid: L_NTH_PERCENTILE_INST L_LPAREN sid_vec L_COMMA integer L_RPAREN  */
#line 552 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2305 "query_parser.tab.c"
    break;

  case 82: /* func_sid: L_NTH_PERCENTILE_INST L_LPAREN func_sid L_COMMA integer L_RPAREN  */
#line 565 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2322 "query_parser.tab.c"
    break;

  case 83: /* func_sid: L_NTH_PERCENTILE_SAMPLE L_LPAREN sid_vec L_COMMA integer L_RPAREN  */
#line 578 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2339 "query_parser.tab.c"
    break;

  case 84: /* func_sid: L_NTH_PERCENTILE_SAMPLE L_LPAREN func_sid L_COMMA integer L_RPAREN  */
#line 591 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2356 "query_parser.tab.c"
    break;

  case 85: /* func_sid: L_AVG L_LPAREN sid_vec L_RPAREN  */
#line 604 "query_parser.y"
                { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2365 "query_parser.tab.c"
    break;

  case 86: /* func_sid: L_AVG L_LPAREN func_sid L_RPAREN  */
#line 609 "query_parser.y"
                { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2374 "query_parser.tab.c"
    break;

  case 87: /* func_sid: L_AVG_INST L_LPAREN sid_vec L_RPAREN  */
#line 614 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2383 "query_parser.tab.c"
    break;

  case 88: /* func_sid: L_AVG_INST L_LPAREN func_sid L_RPAREN  */
#line 619 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2392 "query_parser.tab.c"
    break;

  case 89: /* func_sid: L_AVG_SAMPLE L_LPAREN sid_vec L_RPAREN  */
#line 624 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2401 "query_parser.tab.c"
    break;

  case 90: /* func_sid: L_AVG_SAMPLE L_LPAREN func_sid L_RPAREN  */
#line 629 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2410 "query_parser.tab.c"
    break;

  case 91: /* func_sid: L_ABS L_LPAREN sid_vec L_RPAREN  */
#line 634 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2419 "query_parser.tab.c"
    break;

  case 92: /* func_sid: L_ABS L_LPAREN func_sid L_RPAREN  */
#line 639 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2428 "query_parser.tab.c"
    break;

  case 93: /* func_sid: L_FLOOR L_LPAREN sid_vec L_RPAREN  */
#line 644 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2437 "query_parser.tab.c"
    break;

  case 94: /* func_sid: L_FLOOR L_LPAREN func_sid L_RPAREN  */
#line 649 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2446 "query_parser.tab.c"
    break;

  case 95: /* func_sid: L_LOG L_LPAREN sid_vec L_COMMA number L_RPAREN  */
#line 654 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2456 "query_parser.tab.c"
    break;

  case 96: /* func_sid: L_LOG L_LPAREN func_sid L_COMMA number L_RPAREN  */
#line 660 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2466 "query_parser.tab.c"
    break;

  case 97: /* func_sid: L_LOG L_LPAREN sid_vec L_RPAREN  */
#line 666 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2475 "query_parser.tab.c"
    break;

  case 98: /* func_sid: L_LOG L_LPAREN func_sid L_RPAREN  */
#line 671 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2484 "query_parser.tab.c"
    break;

  case 99: /* func_sid: L_SQRT L_LPAREN sid_vec L_RPAREN  */
#line 676 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2493 "query_parser.tab.c"
    break;

  case 100: /* func_sid: L_SQRT L_LPAREN func_sid L_RPAREN  */
#line 681 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2502 "query_parser.tab.c"
    break;

  case 101: /* func_sid: L_ROUND L_LPAREN sid_vec L_RPAREN  */
#line 686 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2511 "query_parser.tab.c"
    break;

  case 102: /* func_sid: L_ROUND L_LPAREN func_sid L_RPAREN  */
#line 691 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2520 "query_parser.tab.c"
    break;

  case 103: /* func_sid: arithmetic_expr_sid  */
#line 696 "query_parser.y"
                { lp->yy_np = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2528 "query_parser.tab.c"
    break;

  case 104: /* arithmetic_expr_sid: sid_vec L_PLUS sid_vec  */
#line 703 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2538 "query_parser.tab.c"
    break;

  case 105: /* arithmetic_expr_sid: sid_vec L_PLUS func_sid  */
#line 709 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2548 "query_parser.tab.c"
    break;

  case 106: /* arithmetic_expr_sid: func_sid L_PLUS sid_vec  */
#line 715 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2558 "query_parser.tab.c"
    break;

  case 107: /* arithmetic_expr_sid: func_sid L_PLUS func_sid  */
#line 721 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2568 "query_parser.tab.c"
    break;

  case 108: /* arithmetic_expr_sid: sid_vec L_MINUS sid_vec  */
#line 727 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2578 "query_parser.tab.c"
    break;

  case 109: /* arithmetic_expr_sid: sid_vec L_MINUS func_sid  */
#line 733 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2588 "query_parser.tab.c"
    break;

  case 110: /* arithmetic_expr_sid: func_sid L_MINUS sid_vec  */
#line 739 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2598 "query_parser.tab.c"
    break;

  case 111: /* arithmetic_expr_sid: func_sid L_MINUS func_sid  */
#line 745 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2608 "query_parser.tab.c"
    break;

  case 112: /* arithmetic_expr_sid: sid_vec L_STAR sid_vec  */
#line 751 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2618 "query_parser.tab.c"
    break;

  case 113: /* arithmetic_expr_sid: sid_vec L_STAR func_sid  */
#line 757 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2628 "query_parser.tab.c"
    break;

  case 114: /* arithmetic_expr_sid: func_sid L_STAR sid_vec  */
#line 763 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2638 "query_parser.tab.c"
    break;

  case 115: /* arithmetic_expr_sid: func_sid L_STAR func_sid  */
#line 769 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2648 "query_parser.tab.c"
    break;

  case 116: /* arithmetic_expr_sid: sid_vec L_SLASH sid_vec  */
#line 775 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2658 "query_parser.tab.c"
    break;

  case 117: /* arithmetic_expr_sid: sid_vec L_SLASH func_sid  */
#line 781 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2668 "query_parser.tab.c"
    break;

  case 118: /* arithmetic_expr_sid: func_sid L_SLASH sid_vec  */
#line 787 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2678 "query_parser.tab.c"
    break;

  case 119: /* arithmetic_expr_sid: func_sid L_SLASH func_sid  */
#line 793 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2688 "query_parser.tab.c"
    break;

  case 120: /* func: L_RATE L_LPAREN val_vec L_RPAREN  */
#line 801 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2697 "query_parser.tab.c"
    break;

  case 121: /* func: L_RATE L_LPAREN func L_RPAREN  */
#line 806 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2706 "query_parser.tab.c"
    break;

  case 122: /* func: L_MAX L_LPAREN val_vec L_RPAREN  */
#line 811 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2715 "query_parser.tab.c"
    break;

  case 123: /* func: L_MAX L_LPAREN func L_RPAREN  */
#line 816 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2724 "query_parser.tab.c"
    break;

  case 124: /* func: L_MAX_INST L_LPAREN val_vec L_RPAREN  */
#line 821 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2733 "query_parser.tab.c"
    break;

  case 125: /* func: L_MAX_INST L_LPAREN func L_RPAREN  */
#line 826 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2742 "query_parser.tab.c"
    break;

  case 126: /* func: L_MAX_SAMPLE L_LPAREN val_vec L_RPAREN  */
#line 831 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2751 "query_parser.tab.c"
    break;

  case 127: /* func: L_MAX_SAMPLE L_LPAREN func L_RPAREN  */
#line 836 "query_parser.y"
                { lp->yy_np = newnode(N_MAX_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2760 "query_parser.tab.c"
    break;

  case 128: /* func: L_MIN L_LPAREN val_vec L_RPAREN  */
#line 841 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2769 "query_parser.tab.c"
    break;

  case 129: /* func: L_MIN L_LPAREN func L_RPAREN  */
#line 846 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2778 "query_parser.tab.c"
    break;

  case 130: /* func: L_MIN_INST L_LPAREN val_vec L_RPAREN  */
#line 851 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2787 "query_parser.tab.c"
    break;

  case 131: /* func: L_MIN_INST L_LPAREN func L_RPAREN  */
#line 856 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2796 "query_parser.tab.c"
    break;

  case 132: /* func: L_MIN_SAMPLE L_LPAREN val_vec L_RPAREN  */
#line 861 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2805 "query_parser.tab.c"
    break;

  case 133: /* func: L_MIN_SAMPLE L_LPAREN func L_RPAREN  */
#line 866 "query_parser.y"
                { lp->yy_np = newnode(N_MIN_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2814 "query_parser.tab.c"
    break;

  case 134: /* func: L_RESCALE L_LPAREN val_vec L_COMMA L_STRING L_RPAREN  */
#line 871 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2836 "query_parser.tab.c"
    break;

  case 135: /* func: L_RESCALE L_LPAREN func L_COMMA L_STRING L_RPAREN  */
#line 889 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2858 "query_parser.tab.c"
    break;

  case 136: /* func: L_ABS L_LPAREN val_vec L_RPAREN  */
#line 907 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2867 "query_parser.tab.c"
    break;

  case 137: /* func: L_ABS L_LPAREN func L_RPAREN  */
#line 912 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2876 "query_parser.tab.c"
    break;

  case 138: /* func: L_FLOOR L_LPAREN val_vec L_RPAREN  */
#line 917 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2885 "query_parser.tab.c"
    break;

  case 139: /* func: L_FLOOR L_LPAREN func L_RPAREN  */
#line 922 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2894 "query_parser.tab.c"
    break;

  case 140: /* func: L_LOG L_LPAREN val_vec L_COMMA number L_RPAREN  */
#line 927 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2904 "query_parser.tab.c"
    break;

  case 141: /* func: L_LOG L_LPAREN func L_COMMA number L_RPAREN  */
#line 933 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2914 "query_parser.tab.c"
    break;

  case 142: /* func: L_LOG L_LPAREN val_vec L_RPAREN  */
#line 939 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2923 "query_parser.tab.c"
    break;

  case 143: /* func: L_LOG L_LPAREN func L_RPAREN  */
#line 944 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2932 "query_parser.tab.c"
    break;

  case 144: /* func: L_SQRT L_LPAREN val_vec L_RPAREN  */
#line 949 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2941 "query_parser.tab.c"
    break;

  case 145: /* func: L_SQRT L_LPAREN func L_RPAREN  */
#line 954 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2950 "query_parser.tab.c"
    break;

  case 146: /* func: L_ROUND L_LPAREN val_vec L_RPAREN  */
#line 959 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2959 "query_parser.tab.c"
    break;

  case 147: /* func: L_ROUND L_LPAREN func L_RPAREN  */
#line 964 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2968 "query_parser.tab.c"
    break;

  case 148: /* func: L_SUM L_LPAREN val_vec L_RPAREN  */
#line 969 "query_parser.y"
                { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2977 "query_parser.tab.c"
    break;

  case 149: /* func: L_SUM L_LPAREN func L_RPAREN  */
#line 974 "query_parser.y"
                { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2986 "query_parser.tab.c"
    break;

  case 150: /* func: L_SUM_INST L_LPAREN val_vec L_RPAREN  */
#line 979 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2995 "query_parser.tab.c"
    break;

  case 151: /* func: L_SUM_INST L_LPAREN func L_RPAREN  */
#line 984 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3004 "query_parser.tab.c"
    break;

  case 152: /* func: L_SUM_SAMPLE L_LPAREN val_vec L_RPAREN  */
#line 989 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3013 "query_parser.tab.c"
    break;

  case 153: /* func: L_SUM_SAMPLE L_LPAREN func L_RPAREN  */
#line 994 "query_parser.y"
                { lp->yy_np = newnode(N_SUM_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3022 "query_parser.tab.c"
    break;

  case 154: /* func: L_STDEV_INST L_LPAREN val_vec L_RPAREN  */
#line 999 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3031 "query_parser.tab.c"
    break;

  case 155: /* func: L_STDEV_INST L_LPAREN func L_RPAREN  */
#line 1004 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3040 "query_parser.tab.c"
    break;

  case 156: /* func: L_STDEV_SAMPLE L_LPAREN val_vec L_RPAREN  */
#line 1009 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3049 "query_parser.tab.c"
    break;

  case 157: /* func: L_STDEV_SAMPLE L_LPAREN func L_RPAREN  */
#line 1014 "query_parser.y"
                { lp->yy_np = newnode(N_STDEV_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3058 "query_parser.tab.c"
    break;

  case 158: /* func: L_TOPK_INST L_LPAREN val_vec L_COMMA integer L_RPAREN  */
#line 1019 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3068 "query_parser.tab.c"
    break;

  case 159: /* func: L_TOPK_INST L_LPAREN func L_COMMA integer L_RPAREN  */
#line 1025 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3078 "query_parser.tab.c"
    break;

  case 160: /* func: L_TOPK_SAMPLE L_LPAREN val_vec L_COMMA integer L_RPAREN  */
#line 1031 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3088 "query_parser.tab.c"
    break;

  case 161: /* func: L_TOPK_SAMPLE L_LPAREN func L_COMMA integer L_RPAREN  */
#line 1037 "query_parser.y"
                { lp->yy_np = newnode(N_TOPK_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3098 "query_parser.tab.c"
    break;

  case 162: /* func: L_NTH_PERCENTILE_INST L_LPAREN val_vec L_COMMA integer L_RPAREN  */
#line 1043 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3115 "query_parser.tab.c"
    break;

  case 163: /* func: L_NTH_PERCENTILE_INST L_LPAREN func L_COMMA integer L_RPAREN  */
#line 1056 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_INST);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3132 "query_parser.tab.c"
    break;

  case 164: /* func: L_NTH_PERCENTILE_SAMPLE L_LPAREN val_vec L_COMMA integer L_RPAREN  */
#line 1069 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3149 "query_parser.tab.c"
    break;

  case 165: /* func: L_NTH_PERCENTILE_SAMPLE L_LPAREN func L_COMMA integer L_RPAREN  */
#line 1082 "query_parser.y"
                { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[-1].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3166 "query_parser.tab.c"
    break;

  case 166: /* func: L_AVG L_LPAREN val_vec L_RPAREN  */
#line 1095 "query_parser.y"
                { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3175 "query_parser.tab.c"
    break;

  case 167: /* func: L_AVG L_LPAREN func L_RPAREN  */
#line 1100 "query_parser.y"
                { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3184 "query_parser.tab.c"
    break;

  case 168: /* func: L_AVG_INST L_LPAREN val_vec L_RPAREN  */
#line 1105 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3193 "query_parser.tab.c"
    break;

  case 169: /* func: L_AVG_INST L_LPAREN func L_RPAREN  */
#line 1110 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_INST);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3202 "query_parser.tab.c"
    break;

  case 170: /* func: L_AVG_SAMPLE L_LPAREN val_vec L_RPAREN  */
#line 1115 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3211 "query_parser.tab.c"
    break;

  case 171: /* func: L_AVG_SAMPLE L_LPAREN func L_RPAREN  */
#line 1120 "query_parser.y"
                { lp->yy_np = newnode(N_AVG_SAMPLE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3220 "query_parser.tab.c"
    break;

  case 172: /* func: arithmetic_expression  */
#line 1125 "query_parser.y"
                { lp->yy_np = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3228 "query_parser.tab.c"
    break;

  case 173: /* arithmetic_expression: val_vec L_PLUS val_vec  */
#line 1132 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3238 "query_parser.tab.c"
    break;

  case 174: /* arithmetic_expression: val_vec L_PLUS func  */
#line 1138 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3248 "query_parser.tab.c"
    break;

  case 175: /* arithmetic_expression: func L_PLUS val_vec  */
#line 1144 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3258 "query_parser.tab.c"
    break;

  case 176: /* arithmetic_expression: func L_PLUS func  */
#line 1150 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3268 "query_parser.tab.c"
    break;

  case 177: /* arithmetic_expression: val_vec L_MINUS val_vec  */
#line 1156 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3278 "query_parser.tab.c"
    break;

  case 178: /* arithmetic_expression: val_vec L_MINUS func  */
#line 1162 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3288 "query_parser.tab.c"
    break;

  case 179: /* arithmetic_expression: func L_MINUS val_vec  */
#line 1168 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3298 "query_parser.tab.c"
    break;

  case 180: /* arithmetic_expression: func L_MINUS func  */
#line 1174 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3308 "query_parser.tab.c"
    break;

  case 181: /* arithmetic_expression: val_vec L_STAR val_vec  */
#line 1180 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3318 "query_parser.tab.c"
    break;

  case 182: /* arithmetic_expression: val_vec L_STAR func  */
#line 1186 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3328 "query_parser.tab.c"
    break;

  case 183: /* arithmetic_expression: func L_STAR val_vec  */
#line 1192 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3338 "query_parser.tab.c"
    break;

  case 184: /* arithmetic_expression: func L_STAR func  */
#line 1198 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3348 "query_parser.tab.c"
    break;

  case 185: /* arithmetic_expression: val_vec L_SLASH val_vec  */
#line 1204 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3358 "query_parser.tab.c"
    break;

  case 186: /* arithmetic_expression: val_vec L_SLASH func  */
#line 1210 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3368 "query_parser.tab.c"
    break;

  case 187: /* arithmetic_expression: func L_SLASH val_vec  */
#line 1216 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3378 "query_parser.tab.c"
    break;

  case 188: /* arithmetic_expression: func L_SLASH func  */
#line 1222 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 3388 "query_parser.tab.c"
    break;


#line 3392 "query_parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (lp, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, lp);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, lp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (lp, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, lp);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, lp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1229 "query_parser.y"


/* function table for lexer */
static const struct {
    int		f_type;
    int		f_namelen;
    char	*f_name;
} func[] = {
    { L_AVG,		sizeof("avg")-1,	"avg" },
    { L_AVG_INST,	sizeof("avg_inst")-1,	"avg_inst" },
    { L_AVG_SAMPLE,	sizeof("avg_sample")-1,	"avg_sample" },
    { L_COUNT,		sizeof("count")-1,	"count" },
    { L_MAX,		sizeof("max")-1,	"max" },
    { L_MAX_INST,	sizeof("max_inst")-1,	"max_inst" },
    { L_MAX_SAMPLE,	sizeof("max_sample")-1,	"max_sample" },
    { L_MIN,		sizeof("min")-1,	"min" },
    { L_MIN_INST,	sizeof("min_inst")-1,	"min_inst" },
    { L_MIN_SAMPLE,	sizeof("min_sample")-1,	"min_sample" },
    { L_SUM,		sizeof("sum")-1,	"sum" },
    { L_SUM_INST,	sizeof("sum_inst")-1,	"sum_inst" },
    { L_SUM_SAMPLE,	sizeof("sum_sample")-1,	"sum_sample" },
    { L_STDEV_INST,	sizeof("stdev_inst")-1,	"stdev_inst" },
    { L_STDEV_SAMPLE,	sizeof("stdev_sample")-1,	"stdev_sample" },
    { L_TOPK_INST,	sizeof("topk_inst")-1,	"topk_inst" },
    { L_TOPK_SAMPLE,	sizeof("topk_sample")-1,	"topk_sample" },
    { L_NTH_PERCENTILE_INST,	sizeof("nth_percentile_inst")-1,	"nth_percentile_inst" },
    { L_NTH_PERCENTILE_SAMPLE,	sizeof("nth_percentile_sample")-1,	"nth_percentile_sample" },
    { L_RATE,		sizeof("rate")-1,	"rate" },
    { L_ABS,		sizeof("abs")-1,	"abs" },
    { L_FLOOR,		sizeof("floor")-1,	"floor" },
    { L_LOG,		sizeof("log")-1,	"log" },
    { L_SQRT,		sizeof("sqrt")-1,	"sqrt" },
    { L_ROUND,		sizeof("round")-1,	"round" },
    { L_RESCALE,	sizeof("rescale")-1,	"rescale" },
    { L_UNDEF,		0,			NULL }
};

static struct {
    int         ltype;
    int         ntype;
    char        *long_name;
    char        *short_name;
} typetab[] = {
    { L_UNDEF,		0,		"UNDEF",	NULL },
    { L_ERROR,		0,		"ERROR",	NULL },
    { L_EOS,		0,		"EOS",		NULL },
    { L_INTEGER,	N_INTEGER,	"INTEGER",	NULL },
    { L_DOUBLE,		N_DOUBLE,	"DOUBLE",	NULL },
    { L_NAME,		N_NAME,		"NAME",		NULL },
    { L_NAME,		N_METRIC,	"METRIC",	NULL },
    { L_NAME,		N_QUERY,	"QUERY",	NULL },
    { L_PLUS,		N_PLUS,		"PLUS",		"+" },
    { L_MINUS,		N_MINUS,	"MINUS",	"-" },
    { L_STAR,		N_STAR,		"STAR",		"*" },
    { L_SLASH,		N_SLASH,	"SLASH",	"/" },
    { L_LPAREN,		0,		"LPAREN",	"(" },
    { L_RPAREN,		0,		"RPAREN",	")" },
    { L_LBRACE,		0,		"LBRACE",	"{" },
    { L_RBRACE,		0,		"RBRACE",	"}" },
    { L_TYPE,		0,		"TYPE",		NULL },
    { L_SEMANTICS,	0,		"SEMANTICS",	NULL },
    { L_UNITS,		0,		"UNITS",	NULL },
    { L_ASSIGN,		0,		"ASSIGN",	"=" },
    { L_COMMA,		0,		"COMMA",	"," },
    { L_STRING,		0,		"STRING",	"\"" },
    { L_ABS,		N_ABS,		"ABS",		NULL },
    { L_FLOOR,		N_FLOOR,	"FLOOR",	NULL },
    { N_LOG,		N_LOG,		"LOG",		NULL },
    { N_SQRT,		N_SQRT,		"SQRT",		NULL },
    { N_ROUND,		N_ROUND,	"ROUND",	NULL },
    { L_AVG,		N_AVG,		"AVG",		NULL },
    { L_AVG_INST,	N_AVG_INST,	"AVG_INST",	NULL },
    { L_AVG_SAMPLE,	N_AVG_SAMPLE,	"AVG_SAMPLE",	NULL },
    { L_COUNT,		N_COUNT,	"COUNT",	NULL },
    { L_DELTA,		N_DELTA,	"DELTA",	NULL },
    { L_MAX,		N_MAX,		"MAX",		NULL },
    { L_MAX_INST,	N_MAX_INST,	"MAX_INST",	NULL },
    { L_MAX_SAMPLE,	N_MAX_SAMPLE,	"MAX_SAMPLE",	NULL },
    { L_MIN,		N_MIN,		"MIN",		NULL },
    { L_MIN_INST,	N_MIN_INST,	"MIN_INST",	NULL },
    { L_MIN_SAMPLE,	N_MIN_SAMPLE,	"MIN_SAMPLE",	NULL },
    { L_SUM,		N_SUM,		"SUM",		NULL },
    { L_SUM_INST,	N_SUM_INST,	"SUM_INST",	NULL },
    { L_SUM_SAMPLE,	N_SUM_SAMPLE,	"SUM_SAMPLE",	NULL },
    { L_STDEV_INST,	N_STDEV_INST,	"STDEV_INST",	NULL },
    { L_STDEV_SAMPLE,	N_STDEV_SAMPLE,	"STDEV_SAMPLE",	NULL },
    { L_TOPK_INST,	N_TOPK_INST,	"TOPK_INST",	NULL },
    { L_TOPK_SAMPLE,	N_TOPK_SAMPLE,	"TOPK_SAMPLE",	NULL },
    { L_NTH_PERCENTILE_INST,	N_NTH_PERCENTILE_INST,	"NTH_PERCENTILE_INST",	NULL },
    { L_NTH_PERCENTILE_SAMPLE, N_NTH_PERCENTILE_SAMPLE, "NTH_PERCENTILE_SAMPLE", NULL },
    { L_ANON,		N_ANON,		"ANON",		NULL },
    { L_RATE,		N_RATE,		"RATE",		NULL },
    { L_INSTANT,	N_INSTANT,	"INSTANT",	NULL },
    { L_MKCONST,	0,		"MKCONST",	NULL },
    { L_RESCALE,	N_RESCALE,	"RESCALE",	NULL },
    { 0,		N_SCALE,	"SCALE",	NULL },
    { L_DEFINED,	N_DEFINED,	"DEFINED",	NULL },
    { L_INTERVAL,	N_INTERVAL,	"INTERVAL",	NULL },
    { L_START,		N_START,	"START",	NULL },
    { L_FINISH,		N_FINISH,	"FINISH",	NULL },
    { L_TIMEZONE,	N_TIMEZONE,	"TIMEZONE",	"TZ" },
    { L_SAMPLES,	N_SAMPLES,	"SAMPLES",	NULL },
    { L_OFFSET,		N_OFFSET,	"OFFSET",	NULL },
    { L_LT,		N_LT,		"LT",		"<" },
    { L_LEQ,		N_LEQ,		"LEQ",		"<=" },
    { L_EQ,		N_EQ,		"EQ",		"==" },
    { L_GLOB,		N_GLOB,		"GLOB",		"~~" },
    { L_GEQ,		N_GEQ,		"GEQ",		">=" },
    { L_GT,		N_GT,		"GT",		">" },
    { L_NEQ,		N_NEQ,		"NEQ",		"!=" },
    { L_REQ,		N_REQ,		"REQ",		"=~" },
    { L_RNE,		N_RNE,		"RNE",		"!~" },
    { L_AND,		N_AND,		"AND",		"&&" },
    { L_OR,		N_OR,		"OR",		"||" },
    { 0,		N_NEG,		"NEG",		"-" },
    { -1,		-1,		NULL,		NULL }
};

/* full name for all node types */
static char *
n_type_str(int type)
{
    int		i;
    static char n_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].long_name;
    pmsprintf(n_eh_str, sizeof(n_eh_str), "unknown type %d!", type);
    return n_eh_str;
}

/* short string for the operator node types */
static char *
n_type_c(int type)
{
    int		i;
    static char n_eh_c[20]; /* big enough for "op XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].short_name;
    pmsprintf(n_eh_c, sizeof(n_eh_c), "op %d!", type);
    return n_eh_c;
}

/* full name for all lex types */
static char *
l_type_str(int type)
{
    int		i;
    static char l_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ltype != -1; i++)
	if (type == typetab[i].ltype)
	    return typetab[i].long_name;
    pmsprintf(l_eh_str, sizeof(l_eh_str), "unknown type %d!", type);
    return l_eh_str;
}

static node_t *
newnode(int type)
{
    node_t	*np;

    if ((np = (node_t *)calloc(1, sizeof(node_t))) == NULL) {
	pmNoMem("pmSeries: newnode", sizeof(node_t), PM_FATAL_ERR);
	/*NOTREACHED*/
    }
    np->type = type;
    return np;
}

static node_t *
newtree(int type, node_t *left, node_t *right)
{
    node_t	*tree = newnode(type);

    tree->left = left;
    tree->right = right;
    return tree;
}

static node_t *
newmetric(sds name)
{
    node_t	*node;
    char	*re;

    /* enable globbing if string contains a non-escaped '*' */
    if ((re = strchr(name, '*')) != NULL &&
	(re == name || (re[-1] != '%' && re[-1] != '\\')))
	node = newnode(N_GLOB);
    else
	node = newnode(N_EQ);

    node->left = newnode(N_NAME);
    node->left->value = sdsnew("metric.name");
    node->right = newnode(N_STRING);
    node->right->value = name;
    return node;
}

static node_t *
newmetricquery(sds name, node_t *query)
{
    node_t	*root = newnode(N_AND);
    node_t	*metric = newmetric(name);

    root->left = metric;
    root->right = query;
    return root;
}

static void
newinterval(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseInterval(string, &tp->delta, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time delta with pmParseInterval:\n%s", error);
	sdsfree(string);
	free(error);
    } else {
	tp->window.delta = string;
    }
}

static int
parsetime(PARSER *lp, struct timeval *result, sds string)
{
    struct timeval start = { 0, 0 };
    struct timeval end = { PM_MAX_TIME_T, 0 };
    char	*error;
    int		sts;

    if ((sts = __pmParseTime(string, &start, &end, result, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time with __pmParseTime:\n%s", error);
	sdsfree(string);
	free(error);
	return sts;
    }
    return 0;
}

static void
newstarttime(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;

    if (parsetime(lp, &tp->start, string) == 0)
	tp->window.start = string;
}

static void
newendtime(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;

    if (parsetime(lp, &tp->end, string) == 0)
	tp->window.end = string;
}

static void
newrange(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseInterval(string, &tp->start, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse range with pmParseInterval:\n%s", error);
	lp->yy_error = sts;
	sdsfree(string);
	free(error);
    } else {
	struct timeval offset;
	gettimeofday(&offset, NULL);
	tsub(&offset, &tp->start);
	tp->start = offset;
	tp->end.tv_sec = PM_MAX_TIME_T;
	tp->window.range = string;
    }
}

static void
newaligntime(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;

    if (parsetime(lp, &tp->align, string) == 0)
	tp->window.align = string;
}

static void
newtimezone(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	e[PM_MAXERRMSGLEN];
    int		sts;

    if ((sts = pmNewZone(string)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse timezone with pmNewZone:\n\"%S\" - %s",
		string, pmErrStr_r(sts, e, sizeof(e)));
	sdsfree(string);
    } else {
	tp->zone = sts;
	tp->window.zone = string;
    }
}

static void
newsamples(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample count requested - \"%S\"", string);
	sdsfree(string);
    } else {
	tp->count = sts;
	tp->window.count = string;
    }
}

static void
newoffset(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample offset requested - \"%S\"", string);
	sdsfree(string);
    } else {
	tp->offset = sts;
	tp->window.offset = string;
    }
}

static void
gramerr(PARSER *lp, const char *phrase, const char *pos, char *arg)
{
   char errmsg[256];

   /* unless lexer has already found something amiss ... */
   if (lp->yy_errstr == NULL) {
	if (pos == NULL)
	    pmsprintf(errmsg, sizeof(errmsg), "%s '%s'", phrase, arg);
	else
	    pmsprintf(errmsg, sizeof(errmsg), "%s expected to %s %s", phrase, pos, arg);
	lp->yy_errstr = sdsnew(errmsg);
	if (lp->yy_error == 0)
	    lp->yy_error = -EINVAL;
   }
}

/* Construct error message buffer for syntactic error */
static char *
parseError(const char *spec, const char *point, const char *msg)
{
    size_t	need = 2 * strlen(spec) + strlen(msg) + 8;
    const char	*p;
    char	*q, *result;

    if ((result = malloc(need)) == NULL)
	return NULL;
    q = result;

    for (p = spec; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    for (p = spec; p != point; p++)
	*q++ = isgraph((int)*p) ? ' ' : *p;
    snprintf(q, need - (q - result), "^ -- ");
    q += 5;
    for (p = msg; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    *q = '\0';
    return result;
}

static int
series_error(PARSER *lp, const char *s)
{
    char	*msg;

    msg = parseError(lp->yy_base, lp->yy_lexicon, s ? s : "syntax error");
    lp->yy_errstr = sdscatfmt(sdsempty(), "cannot parse given string\n\n%s", msg);
    free(msg);

    lp->yy_series.expr = NULL;
    lp->yy_error = -EINVAL;
    return 0;
}

static int
yyerror(PARSER *lp, const char *s)
{
    return series_error(lp, s);
}

static void
unget(PARSER *lp, int c)
{
    lp->yy_lexpeek = c;
}

static int
get(PARSER *lp)
{
    int		c;

    if (lp->yy_lexpeek != 0) {
	c = lp->yy_lexpeek;
	lp->yy_lexpeek = 0;
	return c;
    }
    c = *lp->yy_input;
    if (c == '\0')
	return EOF;
    lp->yy_input++;
    return c;
}

static int
series_lex(YYSTYPE *lvalp, PARSER *lp)
{
    char	*p = lp->yy_tokbuf;
    int		ltype = L_UNDEF;
    int		c, i, len;
    int		firstch = 1;
    int		ret = L_UNDEF;

    for ( ; ret == L_UNDEF; ) {
	c = get(lp);
	if (firstch) {
	    if (isspace((int)c)) continue;
	    lp->yy_lexicon = &lp->yy_input[-1];
	    firstch = 0;
	}
	if (c == EOF) {
	    if (ltype != L_UNDEF) {
		/* force end of last token */
		c = 0;
	    }
	    else {
		/* really the end of the input buffer */
		ret = L_EOS;
		break;
	    }
	}
	if (p == NULL) {
	    lp->yy_tokbuflen = 128;
	    if ((p = (char *)malloc(lp->yy_tokbuflen+1)) == NULL) { /* CID287946 */
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot allocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	}
	else if (p >= &lp->yy_tokbuf[lp->yy_tokbuflen]) {
	    len = p - lp->yy_tokbuf;
	    lp->yy_tokbuflen *= 2;
	    if (!(p = (char *)realloc(lp->yy_tokbuf, lp->yy_tokbuflen+1))) { /* CID287946 */
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot reallocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	    p = &lp->yy_tokbuf[len];
	}

	*p++ = (char)c;

	if (ltype == L_UNDEF) {
	    if (isdigit((int)c))
		ltype = L_INTEGER;
	    else if (c == '.')
		ltype = L_DOUBLE;
	    else if (isalpha((int)c))
		ltype = L_NAME;
	    else {
		switch (c) {
		    case '+':
			*p = '\0';
			ret = L_PLUS;
			break;

		    case '-':
			*p = '\0';
			ret = L_MINUS;
			break;

		    case '*':
			*p = '\0';
			ret = L_STAR;
			break;

		    case '/':
			*p = '\0';
			ret = L_SLASH;
			break;

		    case '(':
			*p = '\0';
			ret = L_LPAREN;
			break;

		    case ')':
			*p = '\0';
			ret = L_RPAREN;
			break;

		    case '{':
			*p = '\0';
			ret = L_LBRACE;
			break;

		    case '}':
			*p = '\0';
			ret = L_RBRACE;
			break;

		    case '[':
			*p = '\0';
			ret = L_LSQUARE;
			break;

		    case ']':
			*p = '\0';
			ret = L_RSQUARE;
			break;

		    case '<':
			ltype = L_LT;
			break;

		    case '=':
			ltype = L_EQ;
			break;

		    case '~':
			ltype = L_GLOB;
			break;

		    case '>':
			ltype = L_GT;
			break;

		    case '!':
			ltype = L_NEQ;
			break;

		    case '&':
			ltype = L_AND;
			break;

		    case '|':
			ltype = L_OR;
			break;

		    case ':':
			*p = '\0';
			ret = L_COLON;
			break;

		    case ',':
			*p = '\0';
			ret = L_COMMA;
			break;

		    case '"':
			ltype = L_STRING;
			break;

		    default:
			*p = '\0';
			lp->yy_errstr = sdsnew("Illegal character");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		}
	    }
	}
	else {
	    if (ltype == L_INTEGER) {
		if (c == '.') {
		    ltype = L_DOUBLE;
		}
		else if (isalpha((int)c)) {
		    ltype = L_RANGE;
		}
		else if (!isdigit((int)c)) {
		    char	*endptr;
		    __uint64_t	check;

		    unget(lp, c);
		    p[-1] = '\0';
		    check = strtoull(lp->yy_tokbuf, &endptr, 10);
		    if (*endptr != '\0' || check > 0xffffffffUL) {
			lp->yy_errstr = sdsnew("Constant value too large");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		    }
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for INTEGER failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_INTEGER;
		    break;
		}
	    }
	    else if (ltype == L_RANGE) {
		if (!isalpha((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for RANGE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_RANGE;
		    break;
		}
	    }
	    else if (ltype == L_DOUBLE) {
		if (!isdigit((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for DOUBLE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_DOUBLE;
		    break;
		}
	    }
	    else if (ltype == L_NAME) {
		if (isalpha((int)c) || isdigit((int)c) ||
		    c == '_' || c == '.' || c == '*' || c == '%' || c == '\\')
		    continue;
		if (c == '(') {
		    /* check for functions ... */
		    len = p - lp->yy_tokbuf - 1;
		    for (i = 0; func[i].f_name != NULL; i++) {
			if (len == func[i].f_namelen &&
			    strncmp(lp->yy_tokbuf, func[i].f_name, len) == 0) {
			    unget(lp, c);
			    p[-1] = '\0';
			    ret = func[i].f_type;
			    break;
			}
		    }
		    if (func[i].f_name != NULL) {
			/* match func name */
			break;
		    }
		}

		/* current character is end of name */
		unget(lp, c);
		p[-1] = '\0';
		if (strcmp(lp->yy_tokbuf, "type") == 0) {
		    ret = L_TYPE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "semantics") == 0) {
		    ret = L_SEMANTICS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "units") == 0) {
		    ret = L_UNITS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "interval") == 0 ||
			 strcmp(lp->yy_tokbuf, "delta") == 0) {
		    ret = L_INTERVAL;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "timezone") == 0 ||
			 strcmp(lp->yy_tokbuf, "tz") == 0) {
		    ret = L_TIMEZONE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "start") == 0 ||
			 strcmp(lp->yy_tokbuf, "begin") == 0) {
		    ret = L_START;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "finish") == 0 ||
			 strcmp(lp->yy_tokbuf, "end") == 0) {
		    ret = L_FINISH;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "samples") == 0 ||
			 strcmp(lp->yy_tokbuf, "count") == 0) {
		    ret = L_SAMPLES;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "offset") == 0 ||
			 strcmp(lp->yy_tokbuf, "from") == 0) {
		    ret = L_OFFSET;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "align") == 0 ||
			 strcmp(lp->yy_tokbuf, "alignment") == 0) {
		    ret = L_ALIGN;
		    break;
		}
		if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for NAME failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_NAME;
		break;
	    }
	    else if (ltype == L_STRING) {
		if (c != '"')
		    continue;
		/* [-1] and [1] to strip quotes */
		p[-1] = '\0';
		if ((lvalp->s = sdsnew(&lp->yy_tokbuf[1])) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for STRING failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_STRING;
		break;
	    }
	    else if (ltype == L_LT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_LEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_LT;
		    break;
		}
	    }
	    else if (ltype == L_GT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_GEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_GT;
		    break;
		}
	    }
	    else if (ltype == L_GLOB) {
		if (c == '~') {
		    *p = '\0';
		    ret = L_GLOB;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_EQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_EQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_REQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_ASSIGN;
		    break;
		}
	    }
	    else if (ltype == L_NEQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_NEQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_RNE;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_AND) {
		if (c == '&') {
		    *p = '\0';
		    ret = L_AND;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_OR) {
		if (c == '|') {
		    *p = '\0';
		    ret = L_OR;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	}
    }

    if (pmDebugOptions.series && pmDebugOptions.appl0)
	fprintf(stderr, "series_lex() -> type=L_%s \"%s\"\n",
		l_type_str(ret), ret == L_EOS ? "" : lp->yy_tokbuf);

    return ret;
}

static int
yylex(YYSTYPE *lvalp, PARSER *lp)
{
    return series_lex(lvalp, lp);
}

static void
series_freetime(timing_t *tp)
{
    sdsfree(tp->window.delta);
    sdsfree(tp->window.align);
    sdsfree(tp->window.start);
    sdsfree(tp->window.end);
    sdsfree(tp->window.range);
    sdsfree(tp->window.count);
    sdsfree(tp->window.offset);
    sdsfree(tp->window.zone);
}

static void
series_dumpexpr(node_t *np, int level)
{
    if (np == NULL)
	return;

    series_dumpexpr(np->left, level+1);

    switch (np->type) {
    case N_NAME: case N_INTEGER: case N_DOUBLE:
	fprintf(stderr, "%*s%s", level*4, "", np->value);
	break;
    case N_STRING:
	fprintf(stderr, "%*s\"%s\"", level*4, "", np->value);
	break;
    case N_LT:  case N_LEQ: case N_EQ:  case N_GEQ: case N_GT:  case N_NEQ:
    case N_AND: case N_OR:  case N_RNE: case N_REQ: case N_NEG: case N_GLOB:
    case N_PLUS: case N_MINUS: case N_STAR: case N_SLASH:
	fprintf(stderr, "%*s%s", level*4, "", n_type_c(np->type));
	break;
    case N_AVG: case N_COUNT:   case N_DELTA:   case N_MAX:     case N_MIN:
    case N_SUM: case N_ANON:    case N_RATE:    case N_INSTANT: case N_RESCALE:
    case N_MAX_INST: case N_MAX_SAMPLE: case N_MIN_INST: case N_MIN_SAMPLE:
    case N_AVG_INST: case N_AVG_SAMPLE: case N_SUM_INST: case N_SUM_SAMPLE:
    case N_STDEV_INST: case N_STDEV_SAMPLE: case N_NTH_PERCENTILE_INST:
    case N_NTH_PERCENTILE_SAMPLE: case N_TOPK_INST: case N_TOPK_SAMPLE: 
	fprintf(stderr, "%*s%s()", level*4, "", n_type_str(np->type));
	break;
    case N_SCALE: {
	char	strbuf[60];

	if (pmUnitsStr_r(&np->meta.units, strbuf, sizeof(strbuf)) == NULL)
	    fprintf(stderr, " [bad units: %d %d %d %d %d %d]",
			np->meta.units.scaleCount, np->meta.units.scaleTime,
			np->meta.units.scaleSpace,
			np->meta.units.dimCount, np->meta.units.dimTime,
			np->meta.units.dimSpace);
	else
	    fprintf(stderr, " [%s]", strbuf);
	break;
	}
    default:
	break;
    }
    fputc('\n', stderr);

    series_dumpexpr(np->right, level+1);
}

int
series_parse(sds query, series_t *sp, sds *err)
{
    PARSER	yp = { .yy_base = query, .yy_input = (char *)query };
    int		sts;

    sts = yyparse(&yp);
    if (yp.yy_tokbuf)
	free(yp.yy_tokbuf);

    if (sts != 0) {
	*err = yp.yy_errstr;
	return yp.yy_error;
    }
    if (yp.yy_series.expr == NULL) {	/* only a window? */
	*err = sdsnew("Invalid series query specification");
	return -EINVAL;
    }

    if (pmDebugOptions.query) {
	fprintf(stderr, "parsed query: %s\n", query);
	series_dumpexpr(yp.yy_series.expr, 0);
	fputc('\n', stderr);
    }

    *sp = yp.yy_series; /* struct copy */
    return sts;
}

int
pmSeriesQuery(pmSeriesSettings *settings, sds query, pmSeriesFlags flags, void *arg)
{
    series_t	sp = {0};
    sds		errstr;
    int		sts;

    series_stats_inc(settings, SERIES_QUERY_CALLS);

    if ((sts = series_parse(query, &sp, &errstr)) != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, errstr, arg);
	return sts;
    }

    sts = series_solve(settings, sp.expr, &sp.time, flags, arg);
    series_freetime(&sp.time);
    return sts;
}

int
pmSeriesLoad(pmSeriesSettings *settings, sds source, pmSeriesFlags flags, void *arg)
{
    series_t	sp = {0};
    sds		errstr;
    int		sts;

    series_stats_inc(settings, SERIES_LOAD_CALLS);

    if ((sts = series_parse(source, &sp, &errstr)) != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, errstr, arg);
	return sts;
    }

    sts = series_load(settings, sp.expr, &sp.time, flags, arg);
    series_freetime(&sp.time);
    return sts;
}

int
pmSeriesWindow(pmSeriesSettings *settings, sds window, pmSeriesTimeWindow *wp, void *arg)
{
    PARSER	yp = { .yy_base = window, .yy_input = (char *)window };
    timing_t	*tp = &yp.yy_series.time;
    sds		error;
    int		sts;

    sts = yyparse(&yp);
    if (yp.yy_tokbuf)
	free(yp.yy_tokbuf);

    if (sts != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, yp.yy_errstr, arg);
	series_freetime(tp);
	return yp.yy_error;
    }
    if (yp.yy_series.expr != NULL) {
	error = sdsnew("Invalid time window specification");
	moduleinfo(&settings->module, PMLOG_ERROR, error, arg);
	series_freetime(tp);
	return -EINVAL;
    }

    *wp = tp->window; /* struct copy */
    return sts;
}
